wxWidgets: wxLocale Class Reference

| Version: 3.1.5

Public Member Functions | Static Public Member Functions | List of all members
wxLocale Class Reference
Class List by Category » Application and System configuration

`#include </home/Hamis/wxwidgets-3.1/wxWidgets3.1-3.1.5-1.i686/src/wxWidgets-3.1.5/interface/wx/intl.h>`

## Detailed Description

wxLocale class encapsulates all language-dependent settings and is a generalization of the C locale concept.

In wxWidgets this class manages current locale. It also initializes and activates wxTranslations object that manages message catalogs.

For a list of the supported languages, please see wxLanguage enum values. These constants may be used to specify the language in wxLocale::Init and are returned by wxLocale::GetSystemLanguage.

wxPerl Note: In wxPerl you can't use the '_' function name, so the `Wx::Locale` module can export the `gettext` and `gettext_noop` under any given name.

# this imports gettext ( equivalent to Wx::GetTranslation
# and gettext_noop ( a noop )
# into your module
use Wx::Locale qw(:default);
# ....
# use the functions
print gettext( "Panic!" );
button = Wx::Button-new( window, -1, gettext( "Label" ) );

If you need to translate a lot of strings, then adding gettext( ) around each one is a long task ( that is why _( ) was introduced ), so just choose a shorter name for gettext:

use Wx::Locale 'gettext' = 't',
'gettext_noop' = 'gettext_noop';
# ...
# use the functions
print t( "Panic!!" );
# ...

##

Library: wxBase

<>< =''>:</>&;&;< =''>\ </></>

See also
  Internationalization, Internationalization Sample, wxXLocale, wxTranslations

## Public Member Functions
| wxLocale ()
| This is the default constructor and it does nothing to initialize the object: Init() must be used to do that. More...
| wxLocale (int language, int flags=wxLOCALE_LOAD_DEFAULT)
| See Init() for parameters description. More...
| wxLocale (const wxString &name, const wxString &shortName=wxEmptyString, const wxString &locale=wxEmptyString, bool bLoadDefault=true)
| See Init() for parameters description. More...
virtual | ~wxLocale ()
| The destructor, like the constructor, also has global side effects: the previously set locale is restored and so the changes described in Init() documentation are rolled back. More...
bool | AddCatalog (const wxString &domain)
| Calls wxTranslations::AddCatalog(const wxString&). More...
bool | AddCatalog (const wxString &domain, wxLanguage msgIdLanguage)
| Calls wxTranslations::AddCatalog(const wxString&, wxLanguage). More...
bool | AddCatalog (const wxString &domain, wxLanguage msgIdLanguage, const wxString &msgIdCharset)
| Calls wxTranslations::AddCatalog(const wxString&, wxLanguage, const wxString&). More...
wxString | GetCanonicalName () const
| Returns the canonical form of current locale name. More...
wxString | GetHeaderValue (const wxString &header, const wxString &domain=wxEmptyString) const
| Calls wxTranslations::GetHeaderValue(). More...
int | GetLanguage () const
| Returns the wxLanguage constant of current language. More...
const wxString & | GetLocale () const
| Returns the locale name as passed to the constructor or Init(). More...
const wxString & | GetName () const
| Returns the current short name for the locale (as given to the constructor or the Init() function). More...
const wxString & | GetString (const wxString &origString, const wxString &domain=wxEmptyString) const
| Calls wxGetTranslation(const wxString&, const wxString&). More...
const wxString & | GetString (const wxString &origString, const wxString &origString2, unsigned n, const wxString &domain=wxEmptyString) const
| Calls wxGetTranslation(const wxString&, const wxString&, unsigned, const wxString&). More...
wxString | GetSysName () const
| Returns current platform-specific locale name as passed to setlocale(). More...
bool | Init (int language=wxLANGUAGE_DEFAULT, int flags=wxLOCALE_LOAD_DEFAULT)
| Initializes the wxLocale instance. More...
bool | Init (const wxString &name, const wxString &shortName=wxEmptyString, const wxString &locale=wxEmptyString, bool bLoadDefault=true)
bool | IsLoaded (const wxString &domain) const
| Calls wxTranslations::IsLoaded(). More...
bool | IsOk () const
| Returns true if the locale could be set successfully. More...

## Static Public Member Functions
static void | AddCatalogLookupPathPrefix (const wxString &prefix)
| Calls wxFileTranslationsLoader::AddCatalogLookupPathPrefix(). More...
static void | AddLanguage (const wxLanguageInfo &info)
| Adds custom, user-defined language to the database of known languages. More...
static const wxLanguageInfo * | FindLanguageInfo (const wxString &locale)
| This function may be used to find the language description structure for the given locale, specified either as a two letter ISO language code (for example, "pt"), a language code followed by the country code ("pt_BR") or a full, human readable, language description ("Portuguese-Brazil"). More...
static const wxLanguageInfo * | GetLanguageInfo (int lang)
| Returns a pointer to wxLanguageInfo structure containing information about the given language or NULL if this language is unknown. More...
static wxString | GetLanguageName (int lang)
| Returns English name of the given language or empty string if this language is unknown. More...
static wxString | GetLanguageCanonicalName (int lang)
| Returns canonical name (see GetCanonicalName()) of the given language or empty string if this language is unknown. More...
static wxFontEncoding | GetSystemEncoding ()
| Tries to detect the user's default font encoding. More...
static wxString | GetSystemEncodingName ()
| Tries to detect the name of the user's default font encoding. More...
static int | GetSystemLanguage ()
| Tries to detect the user's default locale setting. More...
static wxString | GetInfo (wxLocaleInfo index, wxLocaleCategory cat=wxLOCALE_CAT_DEFAULT)
| Get the values of the given locale-dependent datum. More...
static wxString | GetOSInfo (wxLocaleInfo index, wxLocaleCategory cat=wxLOCALE_CAT_DEFAULT)
| Get the values of a locale datum in the OS locale. More...
static bool | IsAvailable (int lang)
| Check whether the operating system and/or C run time environment supports this locale. More...

## Constructor & Destructor Documentation

## ◆ wxLocale() [1/3]

wxLocale::wxLocale | ( |  | ) |

This is the default constructor and it does nothing to initialize the object: Init() must be used to do that.

## ◆ wxLocale() [2/3]

wxLocale::wxLocale | ( | int | language,
|  | int | flags = `wxLOCALE_LOAD_DEFAULT`
| ) |  |

See Init() for parameters description.

## ◆ wxLocale() [3/3]

wxLocale::wxLocale | ( | const wxString & | name,
|  | const wxString & | shortName = `wxEmptyString`,
|  | const wxString & | locale = `wxEmptyString`,
|  | bool | bLoadDefault = `true`
| ) |  |

See Init() for parameters description.

The call of this function has several global side effects which you should understand: first of all, the application locale is changed - note that this will affect many of standard C library functions such as printf() or strftime(). Second, this wxLocale object becomes the new current global locale for the application and so all subsequent calls to wxGetTranslation() will try to translate the messages using the message catalogs for this locale.

## ◆ ~wxLocale()

virtual wxLocale::~wxLocale | ( |  | ) |
| virtual

The destructor, like the constructor, also has global side effects: the previously set locale is restored and so the changes described in Init() documentation are rolled back.

## Member Function Documentation

## ◆ AddCatalog() [1/3]

bool wxLocale::AddCatalog | ( | const wxString & | domain | ) |

Calls wxTranslations::AddCatalog(const wxString&).

## ◆ AddCatalog() [2/3]

bool wxLocale::AddCatalog | ( | const wxString & | domain,
|  | wxLanguage | msgIdLanguage
| ) |  |

Calls wxTranslations::AddCatalog(const wxString&, wxLanguage).

## ◆ AddCatalog() [3/3]

bool wxLocale::AddCatalog | ( | const wxString & | domain,
|  | wxLanguage | msgIdLanguage,
|  | const wxString & | msgIdCharset
| ) |  |

Calls wxTranslations::AddCatalog(const wxString&, wxLanguage, const wxString&).

## ◆ AddCatalogLookupPathPrefix()

static void wxLocale::AddCatalogLookupPathPrefix | ( | const wxString & | prefix | ) |
| static

Calls wxFileTranslationsLoader::AddCatalogLookupPathPrefix().

## ◆ AddLanguage()

static void wxLocale::AddLanguage | ( | const wxLanguageInfo & | info | ) |
| static

Adds custom, user-defined language to the database of known languages.

This database is used in conjunction with the first form of Init().

## ◆ FindLanguageInfo()

static const wxLanguageInfo * wxLocale::FindLanguageInfo | ( | const wxString & | locale | ) |
| static

This function may be used to find the language description structure for the given locale, specified either as a two letter ISO language code (for example, "pt"), a language code followed by the country code ("pt_BR") or a full, human readable, language description ("Portuguese-Brazil").

Returns the information for the given language or NULL if this language is unknown. Note that even if the returned pointer is valid, the caller should not delete it.

See also
  GetLanguageInfo()

## ◆ GetCanonicalName()

wxString wxLocale::GetCanonicalName | ( |  | ) | const

Returns the canonical form of current locale name.

Canonical form is the one that is used on UNIX systems: it is a two- or five-letter string in xx or xx_YY format, where xx is ISO 639 code of language and YY is ISO 3166 code of the country. Examples are "en", "en_GB", "en_US" or "fr_FR". This form is internally used when looking up message catalogs. Compare GetSysName().

## ◆ GetHeaderValue()

wxString wxLocale::GetHeaderValue | ( | const wxString & | header,
|  | const wxString & | domain = `wxEmptyString`
| ) |  | const

Calls wxTranslations::GetHeaderValue().

## ◆ GetInfo()

static wxString wxLocale::GetInfo | ( | wxLocaleInfo | index,
|  | wxLocaleCategory | cat = `wxLOCALE_CAT_DEFAULT`
| ) |  |
| static

Get the values of the given locale-dependent datum.

This function returns the value of the locale-specific option specified by the given index.

Parameters

  index | One of the elements of wxLocaleInfo enum.
  cat | The category to use with the given index or wxLOCALE_CAT_DEFAULT if the index can only apply to a single category.

Returns
  The option value or empty string if the function failed.

## ◆ GetLanguage()

int wxLocale::GetLanguage | ( |  | ) | const

Returns the wxLanguage constant of current language.

Note that you can call this function only if you used the form of Init() that takes wxLanguage argument.

## ◆ GetLanguageCanonicalName()

static wxString wxLocale::GetLanguageCanonicalName | ( | int | lang | ) |
| static

Returns canonical name (see GetCanonicalName()) of the given language or empty string if this language is unknown.

See GetLanguageInfo() for a remark about special meaning of `wxLANGUAGE_DEFAULT`.

Since
  2.9.1

## ◆ GetLanguageInfo()

static const wxLanguageInfo * wxLocale::GetLanguageInfo | ( | int | lang | ) |
| static

Returns a pointer to wxLanguageInfo structure containing information about the given language or NULL if this language is unknown.

Note that even if the returned pointer is valid, the caller should not delete it.

See AddLanguage() for the wxLanguageInfo description. As with Init(), `wxLANGUAGE_DEFAULT` has the special meaning if passed as an argument to this function and in this case the result of GetSystemLanguage() is used.

## ◆ GetLanguageName()

static wxString wxLocale::GetLanguageName | ( | int | lang | ) |
| static

Returns English name of the given language or empty string if this language is unknown.

See GetLanguageInfo() for a remark about special meaning of `wxLANGUAGE_DEFAULT`.

## ◆ GetLocale()

const wxString & wxLocale::GetLocale | ( |  | ) | const

Returns the locale name as passed to the constructor or Init().

This is a full, human-readable name, e.g. "English" or "French".

## ◆ GetName()

const wxString & wxLocale::GetName | ( |  | ) | const

Returns the current short name for the locale (as given to the constructor or the Init() function).

## ◆ GetOSInfo()

static wxString wxLocale::GetOSInfo | ( | wxLocaleInfo | index,
|  | wxLocaleCategory | cat = `wxLOCALE_CAT_DEFAULT`
| ) |  |
| static

Get the values of a locale datum in the OS locale.

This function is similar to GetInfo() and, in fact, identical to it under non-MSW systems. Under MSW it differs from it when no locale had been explicitly set: GetInfo() returns the values corresponding to the "C" locale used by the standard library functions, while this method returns the values used by the OS which, in Windows case, correspond to the user settings in the control panel.

Since
  3.1.0

## ◆ GetString() [1/2]

const wxString & wxLocale::GetString | ( | const wxString & | origString,
|  | const wxString & | domain = `wxEmptyString`
| ) |  | const

Calls wxGetTranslation(const wxString&, const wxString&).

## ◆ GetString() [2/2]

const wxString & wxLocale::GetString | ( | const wxString & | origString,
|  | const wxString & | origString2,
|  | unsigned | n,
|  | const wxString & | domain = `wxEmptyString`
| ) |  | const

Calls wxGetTranslation(const wxString&, const wxString&, unsigned, const wxString&).

## ◆ GetSysName()

wxString wxLocale::GetSysName | ( |  | ) | const

Returns current platform-specific locale name as passed to setlocale().

Compare GetCanonicalName().

## ◆ GetSystemEncoding()

static wxFontEncoding wxLocale::GetSystemEncoding | ( |  | ) |
| static

Tries to detect the user's default font encoding.

Returns wxFontEncoding() value or `wxFONTENCODING_SYSTEM` if it couldn't be determined.

## ◆ GetSystemEncodingName()

static wxString wxLocale::GetSystemEncodingName | ( |  | ) |
| static

Tries to detect the name of the user's default font encoding.

This string isn't particularly useful for the application as its form is platform-dependent and so you should probably use GetSystemEncoding() instead.

Returns a user-readable string value or an empty string if it couldn't be determined.

## ◆ GetSystemLanguage()

static int wxLocale::GetSystemLanguage | ( |  | ) |
| static

Tries to detect the user's default locale setting.

Returns the wxLanguage value or `wxLANGUAGE_UNKNOWN` if the language-guessing algorithm failed.

Note
  This function works with locales and returns the user's default locale. This may be, and usually is, the same as their preferred UI language, but it's not the same thing. Use wxTranslation to obtain language information.

See also
  wxTranslations::GetBestTranslation().

## ◆ Init() [1/2]

bool wxLocale::Init | ( | const wxString & | name,
|  | const wxString & | shortName = `wxEmptyString`,
|  | const wxString & | locale = `wxEmptyString`,
|  | bool | bLoadDefault = `true`
| ) |  |

Deprecated:
  This form is deprecated, use the other one unless you know what you are doing.

Parameters

  name | The name of the locale. Only used in diagnostic messages.
  shortName | The standard 2 letter locale abbreviation; it is used as the directory prefix when looking for the message catalog files.
  locale | The parameter for the call to setlocale(). Note that it is platform-specific.
  bLoadDefault | May be set to false to prevent loading of the message catalog for the given locale containing the translations of standard wxWidgets messages. This parameter would be rarely used in normal circumstances.

## ◆ Init() [2/2]

bool wxLocale::Init | ( | int | language = `wxLANGUAGE_DEFAULT`,
|  | int | flags = `wxLOCALE_LOAD_DEFAULT`
| ) |  |

Initializes the wxLocale instance.

The call of this function has several global side effects which you should understand: first of all, the application locale is changed - note that this will affect many of standard C library functions such as printf() or strftime(). Second, this wxLocale object becomes the new current global locale for the application and so all subsequent calls to wxGetTranslation() will try to translate the messages using the message catalogs for this locale.

Parameters

  language | wxLanguage identifier of the locale. It can be either some concrete language, e.g. `wxLANGUAGE_ESPERANTO`, or a special value `wxLANGUAGE_DEFAULT` which means that wxLocale should use system's default language (see GetSystemLanguage()). Notice that the value `wxLANGUAGE_UNKNOWN` is not allowed here.
  flags | Combination of the following: wxLOCALE_LOAD_DEFAULT: Load the message catalog for the given locale containing the translations of standard wxWidgets messages automatically. wxLOCALE_DONT_LOAD_DEFAULT: Negation of wxLOCALE_LOAD_DEFAULT.

Returns
  true on success or false if the given locale couldn't be set.

## ◆ IsAvailable()

static bool wxLocale::IsAvailable | ( | int | lang | ) |
| static

Check whether the operating system and/or C run time environment supports this locale.

For example in Windows, support for many locales is not installed by default. Returns true if the locale is supported.

The argument lang is the wxLanguage identifier. To obtain this for a given a two letter ISO language code, use FindLanguageInfo() to obtain its wxLanguageInfo structure. See AddLanguage() for the wxLanguageInfo description.

Since
  2.7.1.

## ◆ IsLoaded()

bool wxLocale::IsLoaded | ( | const wxString & | domain | ) | const

Calls wxTranslations::IsLoaded().

## ◆ IsOk()

bool wxLocale::IsOk | ( |  | ) | const

Returns true if the locale could be set successfully.